"""
Filename: CodeLite.py
Author: Mark Clarkson
Date: July, 2012
Description: A simple encryption program
NB: There are two versions of each conversion procedure
"""

# print a menu and get a user's choice. Some basic validation inside a loop
def menu():
    menu = "Code Maker (and Breaker)\n\
1 - Encode a letter\n\
2 - Decode a letter\n\
9 - Exit\n"

    while True:
        option = int(input(menu))
        if option == 1 or option == 2 or option == 9:
            return option
        print("Error, response not recognised\n\n")


"""
These two procedures use simple logic, but a lot of code
"""
        
# Simple logic but a long-winded solution
def convertCharIntSimple():
    char = input("Enter a single letter to convert: ")
    num = 0
    if char == "a" or char == "A":
        num = 1
    elif char == "b" or char == "B":
        num = 2
    elif char == "c" or char == "C":
        num = 3
    elif char == "d" or char == "D":
        num = 4
    elif char == "e" or char == "E":
        num = 5
    elif char == "f" or char == "F":
        num = 6
    elif char == "g" or char == "G":
        num = 7
    elif char == "h" or char == "H":
        num = 8
    elif char == "i" or char == "I":
        num = 9
    elif char == "j" or char == "J":
        num = 10
    elif char == "k" or char == "K":
        num = 11
# repeat up to z

    print(num)


# Simple logic but  alogn winded solution
def convertIntCharSimple():
    num = 0
    while num < 1 or num > 26:
        num = int(input("Enter the code number: "))
        char = ""
        if num == 1:
            char = "a"
        elif num == 2:
            char = "b"
        elif num == 3:
            char = "c"
        elif num == 4:
            char = "d"
        elif num == 5:
            char = "e"
        elif num == 6:
            char = "f"
        elif num == 7:
            char = "g"
        elif num == 8:
            char = "h"
        elif num == 9:
            char = "i"
        elif num == 10:
            char = "j"
        elif num == 11:
            char = "k"
# repeat up to 26
        
        print(char)


"""
These two procedures use MUCH less code, but slightly more complex logic
A basic understanding of ASCII is required
"""

# Less code, but a slightly more complex logic
def convertCharIntASCII():
    char = input("Enter a single letter to convert: ")
    num = ord(char) #gives the ASCII value of that character
    if num < 97: # 97 is the ASCII code for 'a', anything lower is likely to be upper case
        num = num + 32 # 65 is the ASCII code for 'A'. Adding 32 gives the ASCII code for 'a'

    num = num - 96 # numbering now starts from 1

    print(num)

# Less code, but a slightly more complex logic
def convertIntCharASCII():
    num = 0
    while num < 1 or num > 26:
        num = int(input("Enter the code number: "))
        numASCII = num + 96 # convert to ASCII number
        char = chr(numASCII) #convert from ASCII number to character
        print(char)

        
    
while True:
    choice = menu()
    if choice == 1:
        result = convertCharIntSimple()
        #result = convertCharIntASCII()
    elif choice == 2:
        result = convertIntCharSimple()
        #result = convertIntCharASCII()
    else:
        print("Goodbye!")
        break
        
    
